 program stairs;
  uses crt,dos,sysutils,svgadrv,data2;
  var
   i,j:integer;
   p,zast:pointer;
   mainpal,curpal:array[0..255,0..2] of byte;
   pal1,pal2,pal3:pointer;
   MainImage,stbar,savebar,pausebar:pointer;
   keys:array[0..127] of boolean;
   lastkey,key:byte;
   saveint09,exitsave:pointer;
   vseg:word;
   mm:array[0..3] of pointer;
   dg:array[0..1] of pointer;
   sintab:array[-7..40] of integer;
   waitcnt,counter:longint;
   background:pointer;
   winner,level:integer;
  procedure waittick; assembler;
   asm
    mov cx,1024
@01:nop
    loop @01
   end;
  procedure wait(n:word);
   var
    i:integer;
   begin
    for i:=1 to n do waittick;
   end;
  function getkey:byte;
   begin
    key:=lastkey;
    lastkey:=0;
    getkey:=key;
   end;
  procedure vretrace;
   begin
    repeat until port[$3da] and 8=0;
    repeat until port[$3da] and 8>0;
   end;
  procedure fadepal;
   var
    pal:array[0..255,0..2] of byte;
    i,j:integer;
    time:word;
    p:pointer;
   begin
    p:=getpalette;
    move(p^,pal,768);
    for i:=12 downto 0 do begin
     time:=memw[seg0040:$6c];
     for j:=0 to 255 do
      setrgbreg(j,pal[j,0]*i div 12,pal[j,1]*i div 12,pal[j,2]*i div 12,off);
     vretrace;
     vretrace;
    end;
   end;
  procedure showpal(var palette);
   var
    pal:array[0..255,0..2] of byte;
    i,j:integer;
    time:word;
   begin
    move(palette,pal,768);
    for i:=0 to 12 do begin
     time:=memw[seg0040:$6c];
     for j:=0 to 255 do
      setrgbreg(j,pal[j,0]*i div 12,pal[j,1]*i div 12,pal[j,2]*i div 12,off);
     vretrace;
     vretrace;
    end;
   end;
  procedure act2pal(var palette);
   var
    s,o:word;
    i:integer;
   begin
    s:=seg(palette);
    o:=ofs(palette);
    mem[s:o]:=0; mem[s:o+1]:=0; mem[s:o+2]:=0;
    for i:=3 to 767 do
     mem[s:o+i]:=mem[s:o+i] div 4;
   end;
  procedure int09h; interrupt;
   var
    b:byte;
   begin
    b:=port[$60];
    if b<128 then begin keys[b]:=on; lastkey:=b; end
     else keys[b-128]:=off;
    port[$20]:=$20;
   end;
  procedure myexit;
   begin
    if exitcode<>0 then begin
     asm
      mov ax,3
      int 10h
     end;
     writeln('ந諠 訡 ६ 믮: ',exitcode);
     if exitcode=216 then writeln('(襭 )');
    end;
    setintvec(9,saveint09);
    exitproc:=exitsave;
   end;
  procedure initGame;
   begin
    if (memavail<1800000) or (Maxavail<500000) then begin
     writeln('筮   㧪 ! ॡ 2Mb');
     halt;
    end;
    writeln(' 㧪.  ...');
    { 㧪 ࠩ }
    loaddriver('svga32l.dll');
    if hi(getvbever)<2 then begin
     writeln(' 樠樨 ० ॡ  VBE (VESA BIOS Extention)');
     writeln('  2.0!');
     halt;
    end;
    { 㧨 ...}
    opendatfile('stairs.dat',0);
    getdata(1,pal1); act2pal(pal1^);
    move(pal1^,mainpal,768);
    getdata(4,pal1); act2pal(pal1^);
    getdata(6,pal2); act2pal(pal2^);
    getdata(8,pal3); act2pal(pal3^);
    getdata(2,mainimage);
    getdata(3,stbar);
    getdata(5,zast);
    getdata(11,p);
    registerfont(p);
    getdata(10,pausebar);
    closedatfile;
    opendatfile('sprites.dat',0);
    getdata(1,dg[0]);
    getdata(2,dg[1]);
    for i:=0 to 3 do getdata(i+3,mm[i]);
    closedatfile;
    for i:=-7 to 40 do sintab[i]:=round(sin(i*3.1415/16)*32);
{    getmem(savebar,30720);}
    getmem(background,204800);
    {  ⠭ ०}
    setvesamode($4101);
    getmodeinfo($101);
    setparams(640,480);
    setvirtual(640,816,0);
    vseg:=createvseg;

    inline($FA);
    getintvec(9,saveint09);
    setintvec(9,@int09h);
    exitsave:=exitproc;
    exitproc:=@myexit;
    inline($FB);
    repeat until port[$3da] and 8>0;
    repeat until port[$3da] and 8=0;
    waitcnt:=0;
    repeat
     waittick;
     inc(waitcnt);
    until port[$3da] and 8>0;
{    waitcnt:=waitcnt*4 div 5;}

   end;
  procedure putsprite1(x,y,sizex,sizey:integer;var buf;o:word);
   var
    offs:longint;
    s:word;
   begin
    offs:=longint(y)*640+longint(x);
    s:=seg(buf);
    asm
     mov ax,vseg
     mov es,ax
     mov dx,sizey
     db 66h; mov di,word ptr offs
     push ds
     mov si,o
     mov ax,s
     mov ds,ax
     db 66h; mov bx,640
     dw 0
     sub bx,sizex

@02: mov cx,sizex

@01: db 26h,67h,8ah,07h  {mov al,es:[edi]}
     test al,80h
     jnz @skip
     mov al,ds:[si]
     or al,al
     jz @skip
     db 26h,67h,88h,07h   {mov es:[edi],al}
@skip:
     inc si
     db 66h; inc di
     loop @01
     db 66h; add di,bx
     dec dx
     jnz @02

     pop ds
    end;
   end;
  procedure putsprite2(x,y,sizex,sizey:integer;var buf;o:word);
   var
    offs:longint;
    s:word;
   begin
    offs:=longint(y)*640+longint(x);
    s:=seg(buf);
    asm
     mov ax,vseg
     mov es,ax
     mov dx,sizey
     db 66h; mov di,word ptr offs
     push ds
     mov si,o
     mov ax,s
     mov ds,ax
     db 66h; mov bx,640
     dw 0
     sub bx,sizex

@02: mov cx,sizex

@01: db 26h,67h,8ah,07h  {mov al,es:[edi]}
     xor al,0C0h
     test al,0C0h
     jz @skip
     mov al,ds:[si]
     or al,al
     jz @skip
     db 26h,67h,88h,07h   {mov es:[edi],al}
@skip:
     inc si
     db 66h; inc di
     loop @01
     db 66h; add di,bx
     dec dx
     jnz @02

     pop ds
    end;
   end;
  procedure playgame;
   var
    MainSeg:word;
    complete,health:integer;
    x,y,z,scrz:integer;
    dragx,dragy,dragz,dragdir,dphase,savedx,savedy:integer;
    mx,my,mz,mdir,speedx,speedy,mphase,dx,dy,savemx,savemy:integer;
    statuspos,screenpos:longint;
    back1,back2,back3:pointer;
   procedure gamelogic;
    var
     reqdir,reqx,reqy:integer;
    begin
     {஢ઠ ⨩ }
     if keys[75] then mdir:=(mdir+1) and $1f;
     if keys[77] then mdir:=(mdir-1) and $1f;
     if keys[72] then begin
      dx:=sintab[mdir+8]; dy:=sintab[mdir];
      speedx:=speedx+dx div 2; speedy:=speedy+dy div 2;
     end;
     if keys[80] then begin
      dx:=-sintab[mdir+8]; dy:=-sintab[mdir];
      speedx:=speedx+dx div 2; speedy:=speedy+dy div 2;
     end;
     if (speedx<>0) or (speedy<>0) then begin;
      if speedx>192 then speedx:=192;
      if speedx<-192 then speedx:=-192;
      if speedy>192 then speedy:=192;
      if speedy<-192 then speedy:=-192;
{      if keys[72] or keys[80] then begin
       mx:=mx+dx div 2;  my:=my+dy;
      end;}
      mx:=mx+speedx div 8; my:=my+speedy div 8;
      if mx<0 then mx:=0; if mx>2000 then mx:=2000;
      if my<0 then my:=0; if my>1024 then my:=1024;

      mphase:=(mphase+1) and 15;
      if not (keys[72] or keys[80]) then begin
       speedx:=speedx div 2; speedy:=speedy div 2;
      end;
     end;
     { ஢ઠ  }
      j:=mz;
      if (mx>512) and (mx<1536) and (my<512) then begin
       i:=(mz+32+4096) div 512; j:=i*512+(mx-512) div 4+32-4096; end;
      if (mx>512) and (mx<1536) and (my>=512) then begin
       i:=(mz-208+4096) div 512; j:=i*512+(1536-mx) div 4+256+32-4096; end;
      if (mx<512) then j:=((mz+32+4096) div 512)*512+8-4096;
      if (mx>1536) then j:=((mz+32+4096) div 512)*512+256+32-4096;
      if (j<>mz) and (abs(j-mz)>16) then begin
       if mz>j then mz:=mz-16 else mz:=mz+16; end;
      if (j<>mz) and (abs(j-mz)<=16) then mz:=j;

     dphase:=(dphase+1) and 15;
     if abs(dragz-mz)>16 then begin
      if dragz<mz then begin
       if (dragx<512) and (dragy<400) then reqdir:=0;
       if (dragx<512) and (dragy>=400) then reqdir:=24;
       if (dragx>1530) and (dragy<600) then reqdir:=8;
       if (dragx>1530) and (dragy>=600) then reqdir:=16;

       if (dragx>400) and (dragx<=1600) then begin
        if dragy>512 then reqdir:=16 else reqdir:=0;
       end;
      end else begin
       if (dragx<512) and (dragy<600) then reqdir:=8;
       if (dragx<512) and (dragy>=600) then reqdir:=0;
       if (dragx>1530) and (dragy<400) then reqdir:=16;
       if (dragx>1530) and (dragy>=400) then reqdir:=24;

       if (dragx>400) and (dragx<=1600) then begin
        if dragy>512 then reqdir:=0 else reqdir:=16;
       end;
      end;
     end else begin
      if (abs(dragx-mx)+abs(dragy-my))<512 then
       health:=health-2 else
      begin
       if (dragx<mx) and (dragy<my) then reqdir:=4;
       if (dragx>mx) and (dragy<my) then reqdir:=12;
       if (dragx<mx) and (dragy>my) then reqdir:=28;
       if (dragx>mx) and (dragy>my) then reqdir:=20;
      end;
     end;
      i:=dragdir-reqdir;
      if abs(dragdir-32-reqdir)<abs(i) then i:=(dragdir-32-reqdir);
      if abs(dragdir+32-reqdir)<abs(i) then i:=(dragdir-32-reqdir);
      if i>0 then inc(dragdir);
      if i<0 then inc(dragdir);

      if dragdir=reqdir then begin
       dragx:=dragx+sintab[dragdir+8]*(level+4) div 10;
       dragy:=dragy+sintab[dragdir]*(level+4) div 10;
      end else begin
       dragx:=dragx+sintab[dragdir+8]*2 div 6;
       dragy:=dragy+sintab[dragdir]*2 div 6;
      end;
     dragdir:=dragdir and 31;
      j:=dragz;
      if (dragx>512) and (dragx<1536) and (dragy<512) then begin
       i:=(dragz+32+4096) div 512; j:=i*512+(dragx-512) div 4+32-4096; end;
      if (dragx>512) and (dragx<1536) and (dragy>=512) then begin
       i:=(dragz-208+4096) div 512; j:=i*512+(1536-dragx) div 4+256+32-4096; end;
      if (dragx<512) then j:=((dragz+32+4096) div 512)*512+8-4096;
      if (dragx>1536) then j:=((dragz+32+4096) div 512)*512+256+32-4096;
      if (j<>dragz) and (abs(j-dragz)>16) then begin
       if dragz>j then dragz:=dragz-16 else dragz:=dragz+16; end;
      if (j<>dragz) and (abs(j-dragz)<=16) then dragz:=j;
    end;
   procedure makebacks;
    var
     y:integer;
     s:word;
    begin
     s:=seg(background^);
     setvseg(s);
     y:=savemy mod 256;
     getimage(savemx,y,savemx+63,y+62,back1^);
     y:=savedy mod 256;
     getimage(savedx,y,savedx+71,y+62,back2^);
     y:=(statuspos div 640) mod 256;
     absmove4(s,longint(y)*640,seg(back3^),0,30720);
     setvseg(vseg);
    end;
   procedure makestatus;
    var
     s:word;
    begin
     s:=seg(stbar^);
     setvseg(s);
     if health>0 then begin
      setcol(61); bar(190,12,190+health,39);
      setcol(63); hline(190,190+health,12);
      setcol(59); hline(190,190+health,40);
     end;
     if health<100 then begin
      setcol(20); bar(190+health,12,190+100,40);
     end;
{     setcol(1);
     bar(200,2,480,20);
     setfcol(15,0,0);
     wrtstr(200,2,ss(mz));
     wrtstr(250,2,ss(dragz));
     wrtstr(300,2,ss(savedy));
     wrtstr(350,2,ss(screenpos));}
     if mz div (8*((level+3) div 3))>complete then begin
      complete:=mz div (8*((level+3) div 3));
      setcol(34); bar(320,32,320+complete,44);
      setcol(35); hline(320,320+complete,32);
      setcol(33); hline(320,320+complete,44);
      setcol(20); bar(320+complete,32,320+288,44);
     end;
     setvseg(vseg);
    end;
   procedure showstatus(fl:boolean);
    var
     s:word;
    begin
     s:=seg(stbar^);
     if statuspos<>longint((512-((mz+4096) mod 512)) div 2)*640+276480 then begin
      scrollto(0,(512-((mz+4096) mod 512)) div 2);
      if fl then absmove4(seg(savebar^),0,vseg,statuspos,30720);
      statuspos:=longint((512-((mz+4096) mod 512)) div 2)*640+276480;
      absmove4(vseg,statuspos,seg(savebar^),0,30720);
     end;
     absmove4(s,0,vseg,statuspos,30720);
    end;
   begin
    MainSeg:=seg(MainImage^);
    absmove4(mainseg,0,vseg,0,163840);
    absmove4(mainseg,0,vseg,163840,163840);
    absmove4(mainseg,0,vseg,327680,163840);
    absmove4(mainseg,0,seg(background^),0,163840);
    absmove4(mainseg,0,seg(background^),163840,40960);
    getmem(back1,4100); getmem(back2,4612); getmem(back3,30720);

    lastkey:=0; winner:=0;
    health:=100; mx:=250; my:=250; mz:=0; mdir:=0; speedx:=0; speedy:=0;
    dragx:=1800; dragy:=750; dragz:=-256; dragdir:=16;
    mphase:=0; dphase:=0; complete:=0;
    makestatus;

    statuspos:=longint((512-((mz+4096) mod 512)) div 2)*640+276480;
    absmove4(seg(stbar^),0,vseg,statuspos,30720);
    scrollto(0,(512-((mz+4096) mod 512)) div 2);

    screenpos:=(512-((mz+4096) mod 512)) div 2;
    {뢮 m&m}
    x:=mx div 5-my div 24+104; y:=176-my div 64+screenpos;
    savemx:=x; savemy:=y;
    if my>512 then putsprite1(x,y,64,63,mm[mphase div 4]^,(mdir div 4)*4096+64) else
      putsprite2(x,y,64,63,mm[mphase div 4]^,(mdir div 4)*4096+64);
    {뢮 ࠪ}
    x:=dragx div 5-dragy div 24+100; y:=180-dragy div 64+screenpos-(dragz-mz) div 2;
    if (y<720) and (abs(dragz-mz)<512) then begin
     savedx:=x; savedy:=y;
     if dy>512 then putsprite1(x,y,72,63,dg[dphase div 4]^,(dragdir div 4)*4608+72) else
       putsprite2(x,y,72,63,dg[dphase div 4]^,(dragdir div 4)*4608+72);
    end else savedx:=0;

    showpal(mainpal);
    getmem(p,3000);
    getimage(280,400,380,420,p^);
    setfcol(14,20,0);
    wrtstr(280,400,'஢: '+ss(level));
    delay(800);
    putimage(280,400,p^);

    wrtstr(310,400,'3');
    delay(500);
    putimage(280,400,p^);
    wrtstr(310,400,'2');
    delay(500);
    putimage(280,400,p^);
    wrtstr(310,400,'1');
    delay(500);
    putimage(280,400,p^);
    freemem(p);
    repeat { ᭮ ஢ 横 }

     vretrace; { ⮢ ࠦ }
     makestatus;

     makebacks; {⮢ 䮭}
     gamelogic; {ࠡ⪠ ஢ }

     vretrace; {  }
     wait(waitcnt*7 div 8); {      }
     putimage(savemx,savemy,back1^); {ࠥ m&m }

     scrollto(0,(512-((mz+4096) mod 512)) div 2);

     vretrace; {   뢮 }
     if savedx>0 then
      putimage(savedx,savedy,back2^); {ࠥ ࠪ }
     absmove4(seg(back3^),0,vseg,statuspos,30720);
     statuspos:=longint((512-((mz+4096) mod 512)) div 2)*640+276480;


     screenpos:=(512-((mz+4096) mod 512)) div 2;
     x:=mx*4 div 19-my div 24+104; y:=176-my div 64+screenpos;
     {뢮 m&m}
     savemx:=x; savemy:=y;
     if my>512 then putsprite1(x,y,64,63,mm[mphase div 4]^,(mdir div 4)*4096+64) else
       putsprite2(x,y,64,63,mm[mphase div 4]^,(mdir div 4)*4096+64);
    {뢮 ࠪ}
     x:=dragx div 5-dragy div 24+100; y:=180-dragy div 64+screenpos-(dragz-mz) div 2;
     if (y>0) and (y<704) and (abs(mz-dragz)<512) then begin
      savedx:=x; savedy:=y;
      if dragy>512 then putsprite1(x,y,72,63,dg[dphase div 8]^,(dragdir div 4)*4608+72) else
       putsprite2(x,y,72,63,dg[dphase div 8]^,(dragdir div 4)*4608+72);
     end else savedx:=0;

     absmove4(seg(stbar^),0,vseg,statuspos,30720);

     if lastkey<>0 then getkey;
     if complete>=288 then winner:=1;
     if health<=0 then winner:=2;
    until (key=1) or (winner>0); {  ...}
    fadepal;
    scrollto(0,0);
    key:=0;
    freemem(back1); freemem(back2); freemem(back3);
    if winner>0 then begin
     opendatfile('stairs.dat',0);
     if winner=1 then i:=7 else i:=9;
     getdata(i,p);
     closedatfile;
     move(p^,mem[vseg:0],307200);
     if winner=1 then showpal(pal2^) else showpal(pal3^);
     freemem(p);
     lastkey:=0;
     repeat until lastkey>0;
     fadepal;
    end;
    key:=0;
   end;
  begin
   InitGame;
   repeat
    move(zast^,mem[vseg:0],307200);
    showpal(pal1^);
    lastkey:=0; repeat until lastkey<>0; {  ...}
    getkey;
    fadepal;
    if key>1 then begin
     for level:=1 to 5 do begin
      playgame;
      if winner<>1 then break;
     end;
    end;
   until key=1;
   setmode(3);
   writeln('ᨡ  . ,     㤠 :-)');
   writeln;
   writeln(' ᠭ  ⢥   祡 ࠪ⨪ ');
   writeln('㤥⮬   1-  1- 㯯. 25-29  1998 ');
  end.